package org.love.loli;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;


import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGEncodeParam;
import com.sun.image.codec.jpeg.JPEGImageEncoder;

public class ResizeImg {

	 int targetWidth;
	 int targetHeight;
	 BufferedImage img;
	 File targetFile;
	
	 /**
	  * 
	  * @param maxWidth 
	  * @param maxHeight 󳤶
	  * @param filename ļ
	  * @throws IOException 
	  */
	public ResizeImg(int maxWidth , int maxHeight , File srcFilename , File targetFile ) throws IOException{
		img = javax.imageio.ImageIO.read(srcFilename);
		this.targetFile = targetFile;
		int srcWidth = img.getWidth(null);
		int srcHeight = img.getHeight(null);
		double num4 = 0.0;
		double num6 = ((double) srcWidth) / ((double) maxWidth);
		double num5 = ((double) srcHeight) / ((double) maxHeight);
		if (num5 > num6) {
			num4 = num5;
			targetHeight = maxHeight;
			targetWidth = (int) Math
					.round((double) (((double) srcWidth) / num4));
		} else
		{
			num4 = num6;
			targetWidth = maxWidth;
			targetHeight = (int) Math
					.round((double) (((double) srcHeight) / num4));
		}

		if ((srcWidth < maxWidth) & (srcHeight < maxHeight))
		{
			targetWidth = srcWidth;
			targetHeight = srcHeight;
		}
		

	}
	
	/**
	 * 
	 * @param target Ŀļ 
	 * @return
	 * @throws IOException
	 */
	public void resize() throws  IOException{
		BufferedImage _image = new BufferedImage(targetWidth, targetHeight,
				BufferedImage.TYPE_INT_RGB);
		Graphics g = _image.getGraphics();
		if (!g.drawImage(img.getScaledInstance(targetWidth, targetHeight,
				Image.SCALE_SMOOTH), 0, 0, null)) {
			JPEGEncodeParam jep = JPEGCodec.getDefaultJPEGEncodeParam(_image);

			jep.setQuality(1, false);

			FileOutputStream out;
			out = new FileOutputStream(targetFile);
			JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(out);
			encoder.setJPEGEncodeParam(jep);
			encoder.encode(_image);
			out.close();
		}
		g.dispose();
	}
	
	static String targetDir ;
	static String srcDir;
	static int maxWidth;
	static int maxHeight;
	public static void main(String ...argv) throws IOException {

		int len = argv.length;
		int i = 0;
		while (i < len) {


			if (i + 1 < len
					&& (argv[i].equals("-maxwidth"))) {

				maxWidth = Integer.parseInt(argv[i+1]);

				i += 2;
			} else if (i + 1 < len
					&& (argv[i].equals("-maxheight"))) {
				maxHeight = Integer.parseInt(argv[i+1]);

				i += 2;
			} else if (i + 1 < len && argv[i].equals("-srcdir")) {

				srcDir = new File(argv[i+1]).getCanonicalPath();
				i += 2;
			}  else if (i + 1 < len && argv[i].equals("-targetdir")) {

				targetDir =  new File(argv[i+1]).getCanonicalPath();
				i += 2;
			} 
		}
//		maxWidth = 400;
//		maxHeight = 400;
//		srcDir = new File("E:\\ͼƬ").getCanonicalPath();
//		targetDir = new File("e:/imgs").getCanonicalPath();
		resizeFiles(new File(srcDir),1);

	}

	/**
	 * ݹ
	 * @param f
	 * @param level
	 * @throws IOException 
	 */
	private static void resizeFiles(File f, int level) {

		File[] childs = f.listFiles();
		for (int i = 0; i < childs.length; i++) {
			File currentFile = childs[i];
			if(currentFile.isFile() 
					&& currentFile.getName().toLowerCase().matches(".*\\.(jpg|jpeg|png|bmp)$")){
			
				
				try{
					File targetPath = new File(targetDir+
							File.separator+
							currentFile.getCanonicalPath().substring(srcDir.length()));
					if(!targetPath.getParentFile().exists()){
						targetPath.getParentFile().mkdirs();
					}
					System.out.println("==================================");
					System.out.println("Source File:"+currentFile.getCanonicalPath());
					System.out.println("Target File:"+targetPath.getCanonicalPath());
					System.out.println("Reading image....");
					ResizeImg resizeImg = new ResizeImg(maxWidth,
							maxHeight,
							currentFile,
							targetPath);
					System.out.println("Starting.....");
					resizeImg.resize();
					System.out.println("done.");
					
				}catch(IOException e){
					System.out.println("IOException:");
					e.printStackTrace();
				}finally{
					System.out.println("==================================");
				}
				
			}
			if (childs[i].isDirectory()) {
				resizeFiles(currentFile, level + 1);
			}
		}
	}

}
